(document:surround "/std/frame")
(document:insert "/std/functions")
(document:insert "/dialog/frame")
(document:envelop with-translation i18n "alterator-timezone")

(define (string-to-bool str)
    (if	(string=? str "true")
	#t
	(if (string=? str "yes")
	    #t
	    (if	(string=? str "1") #t #f))))

(define (string-to-bool-vc str)
    (make-cell (if	(string=? str "true")
	#t
	(if (string=? str "yes")
	    #t
	    (if	(string=? str "1") #t #f)))))

(define (woo-read-vc path)
    (make-cell (woo-read "/timezones/current"))
)

(define (woo-get-option-cc woo_read_result option_name)
    (make-cell (woo-get-option (car (cell-ref woo_read_result)) option_name))
)

(define (woo-get-option-cv woo_read_result option_name)
    (woo-get-option (car (cell-ref woo_read_result)) option_name)
)

(define (string-list-index-nil-cc entry lst)
    (make-cell
	(or
    	    (string-list-index (cell-ref entry) (cell-ref lst))
    	    0
	)
    )
)

(define zones_list
    (make-cell
	(sort
	    (woo-list-names "/timezones/zonelist")
	    string<?
	)
    )
)

(define woo_timezones_current (woo-read-vc "/timezones/current"))
(define zone_str (woo-get-option-cc woo_timezones_current 'ZONE))
(define zone_num (string-list-index-nil-cc zone_str zones_list))
(define utc_bool (string-to-bool-vc (woo-get-option-cv woo_timezones_current 'UTC)))

(define clock_set_bool (string-to-bool-vc (woo-get-option-cv woo_timezones_current 'HWCLOCK_SET_AT_HALT)))
(define clock_adjust_bool (string-to-bool-vc (woo-get-option-cv woo_timezones_current 'HWCLOCK_ADJUST)))

(define (on-utc-switch)
    (cell-set! utc_bool (utc_chk state))
)
(define (on-clock-set-switch)
    (cell-set! clock_set_bool (clock_set_chk state))
)
(define (on-clock-adjust-switch)
    (cell-set! clock_adjust_bool (clock_adjust_chk state))
)

(document:id main_tabbox (tabbox
    (document:id main_tab_timezone
	(tab (i18n "Time Zone")
	    (gridbox columns "20;60;20"
		(spacer)
		(document:id timezones
		    (listbox
			(rows (cell-ref zones_list))
			current (cell-ref zone_num)
		    )
		)
		(spacer)
		(spacer)
		(document:id utc_chk
		    (checkbox
			(i18n "Hardware clock set to GMT")
			state (cell-ref utc_bool)
			(when toggled (on-utc-switch))
		    )
		)
		(spacer)
	    )
	)
    )
    (document:id main_tab_more
	(tab (i18n "More")
	    (gridbox columns "20;60;20"
		(spacer)
		(document:id clock_set_chk
		    (checkbox 
			(i18n "Set Hardware Clock at halt")
			tooltip (i18n "Whether Hardware Clock should be set to system time at reboot/halt/poweroff.")
			state (cell-ref clock_set_bool)
			(when toggled (on-clock-set-switch))
		    )
		)
		(spacer)
		(spacer)
		(document:id clock_adjust_chk
		    (checkbox 
			(i18n "Adjust Hardware Clock at startup")
			tooltip (i18n "Whether to add or subtract time from the Hardware Clock at startup to account for systematic drift since the last time the clock was set or adjusted at startup.")
			state (cell-ref clock_adjust_bool)
			(when toggled (on-clock-adjust-switch))
		    )
		)
		(spacer)
	    )
	)
    )
))

(define (apply-settings)
    (woo-write "/timezones/current"
    	"UTC" (if (cell-ref utc_bool) "yes" "no")
    	"HWCLOCK_SET_AT_HALT" (if (cell-ref clock_set_bool) "yes" "no")
    	"HWCLOCK_ADJUST" (if (cell-ref clock_adjust_bool) "yes" "no")
	"ZONE" (timezones text))
)

(frame:on-apply (lambda() (apply-settings)))

(frame:buttons-view
    (or (global 'frame:next-button)
        (box orientation "horizontal"
            (button (i18n "Apply") (when clicked (apply-settings)))
            (button (i18n "Quit") (when clicked (document:end)))
        )
    )
)
